/*
 * IConfigurable.java
 *
 * Created on 17. April 2000, 22:01
 */
 
package YARB.Interfaces;
import javax.swing.JFrame;

/** 
 * This Interface provides delcarations for (user-)configurable objects
 * @author  Thomas
 * @version 
 */
public interface IConfigurable 
{
  /**
  * This function forces the object to save ists configuration data to a file
  */
  boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError;
  
  /**
  * This function forces the object to read a configuration from a file
  */
  boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError;
  
  /**
  * Can the object be configured by the user
  */
  boolean IsConfigurable();
  
  /**
  * Shows the configuration dialog provided by the object
  */
  boolean ShowConfigurationDialog(JFrame ParentFrame);
  
  /**
  * Sets the Name of the object
  * This is a user-defined name. Has nothig to do with the toName-Function
  */
  void    setName(String strName);
  
  /**
  * Gets the user defined name of the object.
  * This is a user-defined name. Has nothig to do with the toName-Function
  */
  String  getName();
  
}

