/*
 * IConfigurationReader.java
 *
 * Created on 8. Mai 2000, 09:01
 */
 
package YARB.Interfaces;

/** 
 * This Interface provides funcionality for reading configuration from a file
 * @author  Thomas
 * @version 
 */
public interface IConfigurationReader 
{
  
  /**
  * Opens a tree node with the given name.
  */
  void OpenNode(String NodeName)  throws ECfgReaderError;
  
  /**
  * Closes the last actual tree node
  */
  void CloseNode();
  
  /**
  * Reads the class name
  */
  String  GetClass() throws ECfgReaderError;
  /**
  * Reads the title
  */
  String  getTitle() throws ECfgReaderError;
  /**
  * Reads the file name only for FileSources
  */
  String  getFile() throws ECfgReaderError;
  /**
  * Reads a boolean value that has the given name.
  */
  boolean   getBoolean() throws ECfgReaderError;
  
  /**
  * Reads a integer value that has the given name.
  */
  int       getInt() throws ECfgReaderError;
  
  /**
  * Reads a float value that has the given name.
  */
  float     getfloat() throws ECfgReaderError;
  
  /**
  * Reads a string value that has the given name.
  */
  String    getString() throws ECfgReaderError;

  
  
  //***
  //*** Deklaration of the exception classes:
  //***
  class ECfgReaderError extends Exception
  {
    public ECfgReaderError(String description)
    {
      super(description);
    }
  }

}
