/*
 * IDataProvider.java
 *
 * Created on 17. April 2000, 22:02
 */
 
package YARB.Interfaces;

/** 
 * The IDataProvier interface declares the interface for Objects containing visualization data
 * and that does some data processing.
 * @author  Thomas
 * @version 
 */
public interface IDataProvider extends IConfigurable, IDataRepresentation
{
  /**
  * Starts the data processing task.
  */
  boolean ProcessData() throws DataProcessingError;
  
  /**
  * Frees the internal buffers
  */
  boolean FreeData();
  
  
  
  /**
  * general error exception class for this interface
  */
  class DataProcessingError extends Exception
  {
    public DataProcessingError(String description)
    {
      super(description);
    }
  }
}