/*
 * IDataViewer.java
 *
 * Created on 17. April 2000, 22:03
 */
 
package YARB.Interfaces;
import javax.swing.JFrame;
/** 
 * This is the interface declaration for a data viewer for YARB.
 * A data viewer gets the data by a given data provider and to do the visualization.
 * Additionally it gets the file name for the data file, tah is for two purposes:
 * First, the file name should be dispayed in the title bar of the new JInternalFrame;
 * Second, if a proprierary file viewer is used, the file name could be used directly.
 * @author  Thomas
 * @version 
 */
public interface IDataViewer extends IConfigurable
{

  /*
  * Sets the catption of the new JInternalFrame, that will be displayed in the title bar.
  */
  void setCaption(String strTitle);
  
  /*
  * Sets the data source, that provides the visualization data.
  */
  void setDataSource(IDataProvider DP);
  
  /*
  * Sets the file name for the data file.
  */
  void setFileName( String Name);
  
  /*
  * Starts the visualization.
  * A new JInternalFrame has to be created and the data has to be shown there.
  */
  boolean DoVisualize(IMainFrame ParentFrame) throws IDataProvider.DataProcessingError; 
  
}
