package YARB.Viewer.StdViewer;/*
 * YDVPieChart.java
 *
 * Created on 6. June 2000, 22:04
 */
 

import YARB.Interfaces.*;
import YARB.Main.YDefaultDataHolder;
import YARB.Dialogs.*;
import javax.swing.*;

/** 
 *
 * @author  Erich
 * @version 
 */
public class YDVPieChart extends Object implements IDataViewer
{
  
  private String m_Caption;
  private String m_File;
  private IDataProvider m_DP;

  /** Creates new YDVPlainText */
  public YDVPieChart() {
    m_DP=null;
    m_Caption="";
    m_File="";
  }
  
  public void setCaption(String strTitle) {
    m_Caption=strTitle;
  }
  public void setDataSource(IDataProvider DP) {
    m_DP=DP;
  }
  public void setFileName(String Name) {
    m_File=Name;
  }
  public boolean DoVisualize(IMainFrame ParentFrame) throws IDataProvider.DataProcessingError {
    
    if(m_DP==null){
      return false;
    };
    
    YDefaultDataHolder data=new YDefaultDataHolder();
    
    m_DP.ProcessData();
    data.setData(m_DP);
    m_DP.FreeData();
    
    String str= m_Caption + " (" + m_File + ")" + " [" + m_strName + "]";
    YDVPieChartFrame txt = new YDVPieChartFrame(str);
    txt.setDataHolder(data);
    txt.setLocation(ParentFrame.GetNextCreationPoint());
    ParentFrame.AddFrame(txt);

    
    return true;
  }
  /** This function forces the object to save its configuration data to a file
   */
  public boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError {
    if(Cfg==null) return false;
    
    Cfg.addTitle(getName());
    
    return true;
  }
  
  /** This function forces the object to read a configuration from a file
   */
  public boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError {
    if(Cfg==null) return false;
    
    setName(Cfg.getTitle());
    return true;
  }  
   
  public boolean IsConfigurable() {
    return true;
  }
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
    YStandardNameChooser dlg= new YStandardNameChooser(ParentFrame, "YARB Viewer Properties",true,getName());
    dlg.show();
    
    setName(dlg.getName());
    return true;  
  }
  
  /**
  * Contains the assigned name string.
  */
  private String  m_strName;
  
  /**
  * Assigns a name to the current object.
  */
  public void setName(String strName){
    m_strName=strName;
  }
    
  /**
  * Returns the assigned name of the object
  */
  public String  getName(){
    return m_strName;
  }
  
}