package YARB.Viewer.StdViewer;
/*
 * YDVPlainTextFrame.java
 *
 * Created on 1. Mai 2000, 15:28
 */


import YARB.Interfaces.*;

/** 
 *
 * @author  Thomas
 * @version 
 */
public class YDVPlainTextFrame extends javax.swing.JInternalFrame {

  /** Creates new form YDVPlainTextFrame */
/*  public YDVPlainTextFrame() {
    initComponents ();
    m_data=null;
  }
*/  
  private IDataHolder m_data;
  
  public YDVPlainTextFrame(String strTitle){
    super(strTitle,
                true, //resizable
                true, //closable
                true, //maximizable
                true);//iconifiable
    
    
    initComponents();
        
    setSize(500,500);

    m_data=null;
  }
  
  public YDVPlainTextFrame(String strTitle, IDataHolder dataholder){
    super(strTitle,
                true, //resizable
                true, //closable
                true, //maximizable
                true);//iconifiable

   initComponents();
        
    setSize(500,500);

    setDataHolder(dataholder);
  }
    

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    jScrollPane1 = new javax.swing.JScrollPane ();
    PatternText = new javax.swing.JTextArea ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());


      PatternText.setEditable (false);
  
      jScrollPane1.setViewportView (PatternText);
  

    getContentPane ().add (jScrollPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JTextArea PatternText;
  // End of variables declaration//GEN-END:variables

  public void setDataHolder(IDataHolder data){
    m_data=data;
    Repaint();
  }
  
  public void Repaint()
  {
    PatternText.removeAll();
    
    if(m_data==null){
      return;
    };
    
    String NumbPat= "Number of Pattern:                     " + m_data.numbOfPatterns() + "\n";
    String NumbIU=  "Number of Input Units:                 " + m_data.numbOfInputUnits() + "\n";
    String NumbOU=  "Number of Output Units:                " + m_data.numbOfOutputUnits() + "\n";
    String NumbVI=  "Number of variable Input Dimensions:   " + m_data.numbOfVariableInputDimensions() + "\n";
    String NumbVO=  "Number of variable Output Dimensions:  " + m_data.numbOfVariableOutputDimensions() + "\n";
    String VarInDim="";
    if(m_data.numbOfVariableInputDimensions()>0)
    {
      VarInDim="Variable Input Dimensions:             [";
      for(int k=0; k<m_data.numbOfVariableInputDimensions();k++)
      {
        if(k>0) VarInDim+=",";
        VarInDim+= m_data.getMaxInputDimesion(k);
      };
      
      VarInDim+="]\n";
    };
    String VarOutDim="";
    if(m_data.numbOfVariableOutputDimensions()>0)
    {
      VarOutDim="Variable Output Dimensions:            [";
      for(int k=0; k<m_data.numbOfVariableOutputDimensions();k++)
      {
        if(k>0) VarOutDim+=",";
        VarOutDim+= m_data.getMaxOutputDimesion(k);
      };
      
      VarOutDim+="]\n";
    };
     
    String line=    "---------------------------------------------------------------------------\n";
    String NL=      "\n";
    
    
    PatternText.append(line);
    PatternText.append("PATTERN FILE SUMMARY:\n");
    PatternText.append(NL);
    PatternText.append(NumbPat);
    PatternText.append(NumbIU);
    PatternText.append(NumbOU);
    PatternText.append(NumbVI);
    PatternText.append(NumbVO);
    PatternText.append(VarInDim);
    PatternText.append(VarOutDim);
    PatternText.append(NL);
    PatternText.append(line);
    PatternText.append(NL);
    
    StringBuffer str=   new StringBuffer();
    
    for(int i=0; i<m_data.numbOfPatterns();i++)
    {
      PatternText.append("INPUT PATTERN " + i + ":");
      PatternText.append(NL);
      
      str.delete(0,str.length());
      for(int k=0; k<m_data.numbOfInputUnits();k++)
      {
        str.append("  ").append(m_data.getInputData(i,k));
        
        if((k+1)%10==0)
        {
          PatternText.append(str.append(NL).toString());
          str.delete(0,str.length());
        };
      };
      
      PatternText.append(str.toString());
      
      PatternText.append(NL);
      PatternText.append(line);
      PatternText.append(NL);
      PatternText.append("OUTPUT PATTERN " + i + ":");
      PatternText.append(NL);

      str.delete(0,str.length());
      for(int l=0; l<m_data.numbOfOutputUnits();l++)
      {
        str.append("  ").append(m_data.getOutputData(i,l));
        
        if((l+1)%10==0)
        {
          PatternText.append(str.append(NL).toString());
          str.delete(0,str.length());
        };
      };
      
      PatternText.append(str.toString());
      
      PatternText.append(NL);
      PatternText.append(line);
      PatternText.append(NL);
    };

    PatternText.append(NL);
    PatternText.append(line);
    PatternText.append(" ** E N D * O F * P A T T E R N **");
    PatternText.append(NL);
    PatternText.append(line);
    
  }
}