/*
 * YDVPlainTextFrame.java
 *
 * Created on 1. Mai 2000, 15:28
 */
 
package YARB.Viewer;
import YARB.Interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.Vector;


/** 
 *
 * @author  Thomas
 * @version 
 */
public class YDVDummyFrame extends javax.swing.JInternalFrame {

  /** Creates new form YDVPlainTextFrame */
/*  public YDVPlainTextFrame() {
    initComponents ();
    m_data=null;
  }
*/  

  private IDataHolder m_data;         // Holds the data
  private int m_nCurrentPattern;      // The number of the currently selected pattern
  private boolean m_bCurrentIsInput;  // Is the currently selected pattern an input pattern?
  private Vector  m_vListData;        // Holds the List data

  
  public YDVDummyFrame(String strTitle){
    super(strTitle,
                true, //resizable
                true, //closable
                true, //maximizable
                true);//iconifiable
    
    
    initComponents();
        
    setSize(500,500);
    splitPane.setDividerLocation(100);

    m_data=null;
    m_nCurrentPattern=0;
    m_bCurrentIsInput=true;
    m_vListData=null;
  }
 

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    splitPane = new javax.swing.JSplitPane ();
    patternList = new javax.swing.JList ();
    patternPane = new javax.swing.JScrollPane ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());

    splitPane.setOneTouchExpandable (true);

      patternList.addListSelectionListener (new javax.swing.event.ListSelectionListener () {
        public void valueChanged (javax.swing.event.ListSelectionEvent evt) {
          patternListValueChanged (evt);
        }
      }
      );
  
      splitPane.setLeftComponent (patternList);
  
  
      splitPane.setRightComponent (patternPane);
  

    getContentPane ().add (splitPane, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  
  private void patternListValueChanged (javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_patternListValueChanged
// Add your handling code here:
        if (evt.getValueIsAdjusting())
            return;

        JList theList = (JList)evt.getSource();
        if (theList.isSelectionEmpty()) {
            m_nCurrentPattern=0;
            m_bCurrentIsInput=true;
        } else {
            int index = theList.getSelectedIndex();
            if(m_vListData==null) return;
            
            ListElement e= (ListElement)m_vListData.get(index);
            m_nCurrentPattern=e.getPattern();
            m_bCurrentIsInput=e.isInput();
        }    
        
        // Call the java-swion repaint method (NOT my Repaint!)
        
        repaint();
        
  }//GEN-LAST:event_patternListValueChanged


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSplitPane splitPane;
  private javax.swing.JList patternList;
  private javax.swing.JScrollPane patternPane;
  // End of variables declaration//GEN-END:variables

  public void setDataHolder(IDataHolder data){
    m_data=data;
    Repaint();
  }

  /** Repaints the frame cause the data has changed
  *   NOTE: This method is user-defined and has nothing
  *   to do with the Java-Swing "repaint"-method!!!
  */  
  public void Repaint()
  {
    if(m_data==null) return;  // uups. no data? fuck!

    // Do your On-Data-Change things.

    //** Create the pattern List:
    m_vListData= new Vector();
    
    for(int i=0; i<m_data.numbOfPatterns();i++)
    {
      if (m_data.numbOfInputUnits()>0){
        m_vListData.add(new ListElement(i,true,"- Input pattern " + i));
      };
      if (m_data.numbOfOutputUnits()>0){
        m_vListData.add(new ListElement(i,false,"* Output pattern " + i));
      };
    };
    // Set the new pattern list:
    patternList.setListData(m_vListData);
  }
  
  /** 
  *  This function gives the number of the curently selected pattern in the pattern list
  */
  public int getCurrentPattern(){
    return m_nCurrentPattern;
  }
  
  /**
  * This function says whether the currently selected pattern in the pattern list is an input pattern.
  * Returns true if it is an input pattern or false if it is a output pattern.
  */
  public boolean getCurrentIsInput(){
    return m_bCurrentIsInput;
  }

  /**
  * Returns the paint area's upper left corner.
  */
  private Point getUpperLeftPaintCorner(){
    return new Point(splitPane.getDividerLocation()+splitPane.getDividerSize(),getInsets().top*3);
  }
    
  
  /** Overloading of the Java-Swing paint method for user drawn graphics.
  *   Here the 2D graphics will be painted.
  *   This function is called by the java framework every time when the
  *   frame has to be repainted.
  */
  public void paint(Graphics g)
  {
    // NOTE: Don't forget to let the frame painted by your base class first!
    super.paint(g);   

    // Do your 2D graphics:
    if(m_data==null) return;  // uups. no data? fuck!

    if(getCurrentIsInput())   // Is an input pattern selected?
    {
      // Paint Rectangles:
      Point start=getUpperLeftPaintCorner();
      int xOff= 20;
      int yOff= 20;
      for(int i=0; i< getCurrentPattern()+1; i++)
      {
        g.drawRect(start.x+xOff*(i+1), start.y+yOff*(i+1),15,15);
      };
    }
    else                      // A output pattern is selected.
    {
      // Paint Circles:
      Point start=getUpperLeftPaintCorner();
      int xOff= 20;
      int yOff= 20;
      for(int i=0; i< getCurrentPattern()+1; i++)
      {
        g.drawOval(start.x+xOff*(i+1), start.y+yOff*(i+1),15,15);
      };
    };
  }
 

  /**
  *  ListElement is a container class of information for each list element.
  */
  private class ListElement extends Object
  {
    private int m_nPattern;
    private boolean m_bInput;
    private String m_strTitle;
    
    ListElement(int nPattern,boolean bInput, String strTitle)
    {
      m_nPattern=nPattern;
      m_bInput=bInput;
      m_strTitle=strTitle;
    }
    
      public String toString() {
      return m_strTitle;
    }
    
    int getPattern(){
      return m_nPattern;
    }
    
    boolean isInput(){
      return m_bInput;
    }
  }
}