/*
 * YXMLConfigurationWriter.java
 *
 * Created on 4. Juni 2000, 20:42
 */
 
package YARB.XML;
import YARB.XML.YXMLWriter;
import YARB.Interfaces.*;


/** 
 *
 * @author  Administrator
 * @version 
 */
public class YXMLConfigurationWriter 
extends YXMLWriter 
implements IConfigurationWriter, ICfgFileWrite
{

  /** Creates new YXMLConfigurationWriter */
  public YXMLConfigurationWriter() {
  }
  
  /** Creates a new tree node with the given name and opens it.
   */
  public void CreateNode(String NodeName) throws ECfgWriterError {
    try {
      addNode(NodeName);
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }
  } 
  /** Closes the last actual tree node
   */
  public void CloseNode(String NodeName) throws ECfgWriterError {
    try {
      closeNode(NodeName);
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }
  }
  /** Save the class name of the caller
   */
  public void addClass(String value) throws ECfgWriterError {
    try {
      addElement("Class", value);
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }    
  }
  /** Save the title of the caller
   */
  public void addTitle(String value) throws ECfgWriterError {
    try {
      addElement("Title", value);
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }        
  }
  /** Save the Filesource filename
   */
  public void addFile(String value) throws ECfgWriterError {
    try {
      addElement("File", value);
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }    
  }
  /** Writes a boolean value that has the given name.
   */
  public void addBoolean(boolean value) throws ECfgWriterError {
    try {
      addElement("boolean", "" + value );
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }    
  }
  /** Writes a integer value that has the given name.
   */
  public void addInt(int value) throws ECfgWriterError {
    try {
      addElement("int", "" + value );
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }    
  }
  /** Writes a float value that has the given name.
   */
  public void addfloat(float value) throws ECfgWriterError {
    try {
      addElement("float", "" + value );
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }    
  }
  /** Writes a string value that has the given name.
   */
  public void addString(String value) throws ECfgWriterError {
    try {
      addElement("String", value);
    } catch(ECgfWriterCGeneralError e) {
        throw new ECfgWriterError( e.toString() + "\n" + this.toString() );
    }    
  }
  public void Open(String strPath) {
    SetXMLSource(strPath);
  }
  public void Close() throws ECfgFileWriteError {
    try {
      writeXMLFile();
    } catch (ECgfWriterCGeneralError e) {
      throw new ECfgFileWriteError( e.toString() + " " + "\n" + this.toString() );
    }
  }
  public IConfigurationWriter getWriter() {
    return this;
  }
}
